/***************************************************************************
 *   Copyright (C) 2008 by potlaty   *
 *   potlaty@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Chap.h"

ostream& operator<< ( ostream& out, const ChapUser& user )
{
	out << user.login << " pptpd " << user.pass << " " << user.ip.Str() << endl;
	return out;
}

istream& operator>> ( istream& in, ChapUser& user )
{
	string s;
	
	in >> user.login;
	in >> user.pass;
	in >> user.pass;
	
	in >> s;
	user.ip.Assign( s );
	
	getline(in, s);
	return in;
}

int InsertToChap( const User& user )
{
	string s;
	fstream chap;
	fstream temp;
		
	s.assign( FILE_CHAP_SECRETS );
	chap.open( s.c_str(), ios_base::in );
	if ( !chap ) return 5;
	
	s.assign( DIR_PROGRAM );
	s += FILE_TEMP;
	temp.open( s.c_str(), ios_base::out );
	if ( !temp ) return 6;
	
	int stat = 0;
	ChapUser tmp_chap;
	
	tmp_chap.ip = user.ip;
	tmp_chap.login = user.login;
	tmp_chap.pass = user.pass;
	
	while ( !chap.eof() ){
		getline( chap, s );
		//cout << s << endl;
		if ( s == "#sbills" ) stat++;
		//cout << stat << endl;
		if ( stat == 2 ) { temp << tmp_chap; stat++; }
		temp << s << endl;
	}
	
	if ( stat == 0 ){
		temp << "#sbills" << endl;
		temp << tmp_chap;
		temp << "#sbills" << endl;
	}
	
	chap.close();
	temp.close();
	
	
	
	
	s.assign( FILE_CHAP_SECRETS );
	chap.open( s.c_str(), ios_base::out );
	if ( !chap ) return 7;
	
	s.assign( DIR_PROGRAM );
	s += FILE_TEMP;
	temp.open( s.c_str(), ios_base::in );
	if ( !temp ) return 8;
	
	while ( !temp.eof() ){
		getline( temp, s );
		if ( s != "" ) chap << s << endl;
	}
		
	chap.close();
	temp.close();
	
	return 0;
}

int DeleteFromChap( const User& user )
{
	string s;
	fstream chap;
	fstream temp;
		
	s.assign( FILE_CHAP_SECRETS );
	chap.open( s.c_str(), ios_base::in );
	if ( !chap ) return 5;
	
	s.assign( DIR_PROGRAM );
	s += FILE_TEMP;
	temp.open( s.c_str(), ios_base::out );
	if ( !temp ) return 6;
	
	int stat = 0;
	istringstream ss;
	ChapUser tmp_chap;
	
	while ( !chap.eof() )
		switch ( stat ){
			case 0:
				getline( chap, s );
				if ( s == "#sbills" ) stat ++;
				temp << s << endl;
				break;
			case 1:
				getline( chap, s );
				//cout << "s: " << s << endl;
				if ( s == "#sbills" ) { stat ++; temp << s << endl; break; }
				ss.clear();
				ss.str( s );
				//cout << "ss: " << ss.str() << endl;
				ss >> tmp_chap;
				//cout << "tmp_chap: " << tmp_chap << endl;
				if ( tmp_chap.login != user.login ) temp << tmp_chap;
				break;
			case 2:
				stat = 0;
				break;
		}
		
	chap.close();
	temp.close();
	
	
	
	
	s.assign( FILE_CHAP_SECRETS );
	chap.open( s.c_str(), ios_base::out );
	if ( !chap ) return 7;
	
	s.assign( DIR_PROGRAM );
	s += FILE_TEMP;
	temp.open( s.c_str(), ios_base::in );
	if ( !temp ) return 8;
	
	while ( !temp.eof() ){
		getline( temp, s );
		if ( s != "" ) chap << s << endl;
	}
		
	chap.close();
	temp.close();
	
	return 0;
}


















