/***************************************************************************
 *   Copyright (C) 2008 by potlaty   *
 *   potlaty@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DATABASE_
#define _DATABASE_

#include <string>
#include <vector>

#include "UserContainer.h"
#include "FileSys.h"
#include "Stime.h"
#include "Chap.h"
#include "user.h"
#include "defs.h"
#include "Log.h"

using namespace std;

class DataBase{
public:
	int InsertUser(const User& user);
	int DeleteUser(const string& login);
	int DeleteUser(const IP& ip);
	int FindUser(const IP& ip, User& user);
	int FindUser(const string& login, User& user);
	int GetUserList(vector<User>& users);
	
	int InsertActive(const ActiveUser& user);
	int DeleteActive(const IP& ip);
	int FindActive(const IP& ip, ActiveUser& user);
	int GetActiveList(vector<ActiveUser>& users);
	
	int InsertStat(const Stime& t, const UserStat& st);
	int GetStat(const Stime& t, const IP& ip, UserStat& st);
};

#endif

