/***************************************************************************
 *   Copyright (C) 2008 by potlaty   *
 *   potlaty@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _STIME_
#define _STIME_
#include <string>

const int MAX_YEAR = 9998;

using namespace std;

class Stime{
private:
	int D, M, Y;
public:
	int Refresh();
	int GetY() const {return Y;}
	int GetM() const {return M;}
	int GetD() const {return D;}
	int SetD( int d ) { D=d; }
	
	bool Assign(string);
	string Str() const;
	
	Stime& operator++();
	
	friend bool AssignPeriod(string, Stime&, Stime&);
};

bool operator!=(const Stime&, const Stime&);
bool operator==(const Stime&, const Stime&);
bool operator< (const Stime&, const Stime&);
bool operator<=(const Stime&, const Stime&);

bool AssignPeriod(string, Stime&, Stime&);
string GetTime();

#endif
