/***************************************************************************
 *   Copyright (C) 2008 by potlaty   *
 *   potlaty@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "user.h"

ostream& operator<< (ostream& out, const User& user)
{
	out << user.login << endl;
	out << user.pass << endl;
	out << user.name << endl;
	out << user.ip.Str() << endl;
	out << user.d_limit << endl;
	return out;
}

istream& operator>> (istream& in, User& user)
{
	string s = "";
	getline(in, user.login);
	getline(in, user.pass);
	getline(in, user.name);
	getline(in, s);
	user.ip.Assign( s );
	in >> user.d_limit;
	getline(in, s);
	return in;
}

bool operator == (const User& u1, const User& u2)
{
	return ( u1.GetIP() == u2.GetIP() );
}
		

ostream& operator<< (ostream& out, const ActiveUser& user)
{
	out << user.ip.Str() << " " << user.rx << " " << user.tx << endl;
	return out;
}

istream& operator>> (istream& in, ActiveUser& user)
{
	string s = "";
	in >> s;
	user.ip.Assign( s );
	in >> user.rx;
	in >> user.tx;
	getline(in, s);
	return in;
}

bool operator == (const ActiveUser& u1, const ActiveUser& u2)
{
	return ( u1.GetIP() == u2.GetIP() );
}
