/***************************************************************************
 *   Copyright (C) 2008 by potlaty   *
 *   potlaty@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _USER_
#define _USER_

#include "IP.h"

#include <string>
#include <iostream>

using namespace std;

struct User{
	string name;
	string login;
	string pass;
	
	IP ip;
	
	long long d_limit;
	
	IP GetIP() const {return ip;}
};

ostream& operator<< (ostream&, const User&);
istream& operator>> (istream&, User&);
bool operator == (const User&, const User&);

struct ActiveUser{
	IP ip;
	
	long long rx;
	long long tx;
	
	IP GetIP() const {return ip;}
};

ostream& operator<< (ostream&, const ActiveUser&);
istream& operator>> (istream&, ActiveUser&);
bool operator == (const ActiveUser&, const ActiveUser&);

typedef ActiveUser UserStat;

#endif
